#include <TinyWireM.h>
#include "WiiChuck.h"
#include <SendOnlySoftwareSerial.h>

WiiChuck chuck = WiiChuck();

#define TX_PIN 1

SendOnlySoftwareSerial BT(TX_PIN);

void setup()
{
  BT.begin(9600);
  chuck.begin();
  for (int i=0; i<10; i++)
    chuck.update();
  chuck.calibrateJoy();
}

void mouseCommand(uint8_t buttons, int8_t x, int8_t y) {
  BT.write(0xFD);
  BT.write((byte)0x00);
  BT.write((byte)0x03);
  BT.write(buttons);
  BT.write(x);
  BT.write(y);
  BT.write((byte)0x00);
  BT.write((byte)0x00);
  BT.write((byte)0x00);
}

void loop()
{
  chuck.update();
  int8_t x = chuck.readJoyX()/10;
  int8_t y = -chuck.readJoyY()/10;

  if (chuck.buttonC != chuck.lastC || chuck.buttonZ != chuck.lastZ || x != 0 || y != 0)
    mouseCommand(chuck.buttonC * 0x01 | chuck.buttonZ * 0x02, x, y);
}
